/*
		CirclemudEditorDlg.cpp: implementation of the CirclemudEditorDlg class.

        Copyright (C) 2000 Patrick Dughi

        This software may be used and distributed according to the terms
        of the GNU Public License, incorporated herein by reference, located
		as the file gpl.txt in this same directory.

        The author may be reached at dughi@imaxx.net.

        The primary dialog, which contains the property sheets, as well as global information, such
		as rooms, mobs, and the sort.
	
*/
#pragma warning(disable:4786)
#include "stdafx.h"
#include "Cbreak.h"
#include "DirDialog.h"
#include "CirclemudEditorDlg.h"
#include "Medit.h"
#include "Zedit.h"
#include "Redit.h"
#include "Oedit.h"
#include "Sedit.h"
#include "utils.h"
#include <afxwin.h>
#include <string>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#include <direct.h>
#include <stdlib.h>
#include <stdio.h>


/////////////////////////////////////////////////////////////////////////////
// CirclemudEditorDlg dialog


CirclemudEditorDlg::CirclemudEditorDlg(CWnd* pParent /*=NULL*/)
	: CScrollDialog(CirclemudEditorDlg::IDD, pParent)
{
	locate_world=0;
	current_mob=current_obj=current_room=current_shop=-1;
	no_world=1;
	//{{AFX_DATA_INIT(CirclemudEditorDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void CirclemudEditorDlg::DoDataExchange(CDataExchange* pDX)
{
	CScrollDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CirclemudEditorDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CirclemudEditorDlg, CScrollDialog)
	//{{AFX_MSG_MAP(CirclemudEditorDlg)
	ON_WM_PAINT()
	ON_WM_NCLBUTTONDOWN()
	ON_WM_INITMENUPOPUP()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CirclemudEditorDlg message handlers

void CirclemudEditorDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CScrollDialog::OnPaint();
	}

}


// This could get messy.
CDirDialog ourlib;
World the_world;


extern const char *suffix[NUM_SUFFIX];

void CirclemudEditorDlg::get_world_dir() {	
	char query[4000],fname[2048];
	CFileStatus status;
	int suf=0,found=0;
	extern CDirDialog ourlib;
	FILE *fp;
	string backup;
	locate_world = 0;
	

	ourlib.m_strPath='\0';

	current_mob=current_obj=current_shop=current_room=-1;

	_snprintf(query, 4000,"The following directories did not exist: \n");

	ourlib.m_strTitle = (_T("Select your world directory:"));
  while(!locate_world) {
		backup = iprintf("%s",ourlib.m_strPath);
	  if(!ourlib.DoBrowse()) {
	    locate_world=1;
	    this->EnableWindow(TRUE);
			if(!no_world) {
				ourlib.m_strPath = backup.c_str();
				return;
			}
		} else {
  	  for(suf=0;suf<NUM_SUFFIX;suf++) {
	      if(_snprintf(fname,2048,"%s%s%s",ourlib.m_strPath,
		  	  ourlib.m_strPath.GetAt(ourlib.m_strPath.GetLength()-1) != '\\' ? "\\" : "",
		    	suffix[suf]) < 0) {
			    error("Path name '%s' caused a size error.",fname);
			// something error like here.
				}

			  if(!(CFile::GetStatus(fname, status)) ||	//dne or..	
					!(status.m_attribute & 0x10)) { // ie, it's not a directory 
			  	if(_mkdir(fname) == -1) {
				    error("There was an error creating the %s directory.",fname);
				}
				  fp=fopen(iprintf("%s\\index",fname),"w");
				  fprintf(fp,"$\n",suffix[suf]);
				  fclose(fp);
		      strcat(query,ourlib.m_strPath);
				  if(ourlib.m_strPath.GetAt(ourlib.m_strPath.GetLength()-1) != '\\') {
				    strcat(query,"\\");
				  }
                strcat(query,suffix[suf]);
				  strcat(query,"\n");
				  found=1;
				}
			}

		  if(found) {
	      strcat(query,"\n They were created for you.\n");
	      MessageBox(query);
			}
	    no_world=0;
      locate_world=1;
	    this->EnableWindow(TRUE);
		}
  }

  the_world.more_doors = 0;
	the_world.zone_list.clear();
	the_world.room_list.clear();
	the_world.mob_list.clear();
	the_world.obj_list.clear();
	the_world.shop_list.clear();
	the_world.obj_files.clear();
	the_world.wld_files.clear();
	the_world.zon_files.clear();
	the_world.shp_files.clear();
	if(!no_world) {
    the_world.boot_world();
  }
  if(!the_world.room_list.empty()) {
    current_room= the_world.room_list.begin()->first;
  } else {
    current_room= -1;
  }
  if(!the_world.mob_list.empty()) {
    current_mob= the_world.mob_list.begin()->first;
  } else {
    current_mob= -1;
  }
  if(!the_world.obj_list.empty()) {
    current_obj= the_world.obj_list.begin()->first;
  } else {
    current_obj= -1;
  }
  if(!the_world.shop_list.empty()) {
    current_shop= the_world.shop_list.begin()->first;
  } else {
    current_shop= -1;
  }

  m_dlgPropSheet.SetActivePage(0);
  m_redit.LoadRedit();

}

BOOL CirclemudEditorDlg::OnInitDialog() 
{

	CScrollDialog::OnInitDialog();

  ModifyStyle(0,WS_MAXIMIZEBOX | WS_MINIMIZEBOX,0);
  SetWindowPos(NULL,10,10,0,0,SWP_NOOWNERZORDER |SWP_NOSIZE);

	   // and then add the pages.
  m_dlgPropSheet.AddPage(&m_redit);
  m_dlgPropSheet.AddPage(&m_zedit);
  m_dlgPropSheet.AddPage(&m_medit);
  m_dlgPropSheet.AddPage(&m_oedit);
  m_dlgPropSheet.AddPage(&m_sedit);

  m_dlgPropSheet.Create(this,WS_CHILD|WS_VISIBLE,0);
  m_dlgPropSheet.ModifyStyleEx(0,WS_EX_CONTROLPARENT);
  m_dlgPropSheet.ModifyStyle(0,WS_TABSTOP);
  m_dlgPropSheet.m_psh.dwFlags &= ~PSP_HASHELP;
  m_dlgPropSheet.m_psh.dwFlags |= PSP_HIDEHEADER;

   // Lets hide the other buttons as well.
  CWnd *pWnd = m_dlgPropSheet.GetDlgItem(IDOK);
  pWnd->ShowWindow(FALSE);
  pWnd = m_dlgPropSheet.GetDlgItem(IDCANCEL);
  pWnd->ShowWindow(FALSE);

	CRect rcSheet;
	GetDlgItem(IDC_PROPSHEET)->GetWindowRect(&rcSheet);
	ScreenToClient(&rcSheet);
	m_dlgPropSheet.SetWindowPos(NULL,rcSheet.left-7, rcSheet.top-7,0,0,
		SWP_NOZORDER|SWP_NOSIZE|SWP_NOACTIVATE);

	this->ShowWindow(SW_SHOW);

	this->EnableWindow(FALSE);
	get_world_dir();
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

UINT CirclemudEditorDlg::OnNcLButtonDown (UINT nHitTest, CPoint point)
{
	static int maxmin=0;

	// Optimize if Caption is off
	if(nHitTest == HTMAXBUTTON) {
		if(!maxmin) {
  		  this->ShowWindow(SW_SHOWMAXIMIZED);
		  maxmin=1;
		} else {
		  this->ShowWindow(SW_RESTORE);
		  maxmin=0;
		}
		return Default();
	} else if (nHitTest == HTMINBUTTON) {
		this->ShowWindow(SW_MINIMIZE);
     	return Default();
	} else if (nHitTest == HTCAPTION) {
		// for sticky moving windows. :) I like sticky windows.
        Default();
	}
	return Default();
}


afx_msg void CirclemudEditorDlg::OnInitMenuPopup(CMenu *pPopupMenu,UINT nIndex,BOOL bSysMenu) {
	CWnd* pWnd = GetFocus();
	ImprovedEdit *x = (ImprovedEdit *) pWnd;
    int test,beg,end;
	if(nIndex == 1) {
		if(NULL == pWnd || (pWnd->GetStyle() & ES_READONLY) != 0) {
		  return;
		}

		if(IsEdit(pWnd)) {
  	      test=(x->CanUndo() ? 0 : MF_GRAYED);
	      pPopupMenu->EnableMenuItem(ID_EDIT_UNDO, MF_BYCOMMAND | test);
  
  	  /* there's a selection? */
	      x->GetSel(beg,end);
	      test=((beg!=end) ? 0 : MF_GRAYED);
       	  pPopupMenu->EnableMenuItem(ID_EDIT_CUT,MF_BYCOMMAND|test);
	      pPopupMenu->EnableMenuItem(ID_EDIT_COPY,MF_BYCOMMAND|test);
	      pPopupMenu->EnableMenuItem(ID_EDIT_CLEAR,MF_BYCOMMAND|test);
//	      pPopupMenu->EnableMenuItem(ID_IMPROVEDEDIT_FORMAT,MF_BYCOMMAND|test);
//	      pPopupMenu->EnableMenuItem(ID_IMPROVEDEDIT_FORMATI,MF_BYCOMMAND|test);
         /* clipboard info? */
	      test = (::IsClipboardFormatAvailable(CF_TEXT) ? 0 : MF_GRAYED);
	      pPopupMenu->EnableMenuItem(ID_EDIT_PASTE,MF_BYCOMMAND|test);
		}
	} 
	if(nIndex == 0) {
		if(no_world) {
			pPopupMenu->EnableMenuItem(ID_FILE_SAVEWORLD,MF_BYCOMMAND|MF_GRAYED);
			pPopupMenu->EnableMenuItem(ID_FILE_NEWZONE,MF_BYCOMMAND|MF_GRAYED);
		} else {
			pPopupMenu->EnableMenuItem(ID_FILE_SAVEWORLD,MF_BYCOMMAND|0);
			pPopupMenu->EnableMenuItem(ID_FILE_NEWZONE,MF_BYCOMMAND|0);
		}
	}
}

BOOL CirclemudEditorDlg::IsEdit(CWnd *pWnd)
{
	HWND hWnd;


	if(pWnd == NULL) {
		return FALSE;
	}

	hWnd = pWnd->GetSafeHwnd();

	if(hWnd == NULL) {
		return FALSE;
	}

	TCHAR szClassName[30];
	return ::GetClassName(hWnd,szClassName, 30) && _tcsicmp(szClassName, _T("Edit")) == 0;
}
