/*
		oedit.cpp : implementation file

        Copyright (C) 2000 Patrick Dughi

        This software may be used and distributed according to the terms
        of the GNU Public License, incorporated herein by reference, located
		as the file gpl.txt in this same directory.

        The author may be reached at dughi@imaxx.net.
.		
		Primary control dialog for the oedit window.
*/
#pragma warning(disable:4786)
#include "stdafx.h"
#include <map>
#include <string>
#include <vector>
#include "Cbreak.h"
#include "World.h"
#include "Oedit.h"
#include "ExdescAdd.h"
#include "ObjAff.h"
#include "JumpToObj.h"
#include "IntQuery.h"
#include "YesNoQuery.h"
#include "SpellQuery.h"
#include "LiquidQuery.h"
#include "QueryCont.h"
#include "WeaponQuery.h"
#include "NewObj.h"
#include "BitvectorSel.h"

using namespace std;

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// Oedit property page

IMPLEMENT_DYNCREATE(Oedit, CPropertyPage)

Oedit::Oedit() : CPropertyPage(Oedit::IDD)
{
	//{{AFX_DATA_INIT(Oedit)
	m_exdesc_string = _T("");
	m_adesc = _T("");
	m_aff1 = -1;
	m_aff2 = -1;
	m_aff3 = -1;
	m_aff4 = -1;
	m_aff5 = -1;
	m_aff6 = -1;
	m_alias = _T("");
	m_ldesc = _T("");
	m_mod1 = 0;
	m_mod2 = 0;
	m_mod3 = 0;
	m_mod4 = 0;
	m_mod5 = 0;
	m_mod6 = 0;
	m_rent = 0;
	m_sdesc = _T("");
	m_cost = 0;
	m_weight = 0;
	m_type = -1;
	//}}AFX_DATA_INIT
}

Oedit::~Oedit()
{
}

void Oedit::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(Oedit)
	DDX_Control(pDX, IDC_OBJ_LDESC, e_ldesc);
	DDX_Control(pDX, IDC_OBJ_SDESC, e_sdesc);
	DDX_Control(pDX, IDC_OBJ_ALIAS, e_alias);
	DDX_Control(pDX, IDC_OBJ_ADESC, e_adesc);
	DDX_Control(pDX, IDC_EXDESC_ODESC, e_exdesc_string);
	DDX_Control(pDX, IDC_VALUE4, m_val4);
	DDX_Control(pDX, IDC_VALUE3, m_val3);
	DDX_Control(pDX, IDC_VALUE2, m_val2);
	DDX_Control(pDX, IDC_VALUE1, m_val1);
	DDX_Control(pDX, IDC_OBJ_NUMBER, m_obj_num);
	DDX_Text(pDX, IDC_EXDESC_ODESC, m_exdesc_string);
	DDX_Text(pDX, IDC_OBJ_ADESC, m_adesc);
	DDX_CBIndex(pDX, IDC_OBJ_AFF1, m_aff1);
	DDX_CBIndex(pDX, IDC_OBJ_AFF2, m_aff2);
	DDX_CBIndex(pDX, IDC_OBJ_AFF3, m_aff3);
	DDX_CBIndex(pDX, IDC_OBJ_AFF4, m_aff4);
	DDX_CBIndex(pDX, IDC_OBJ_AFF5, m_aff5);
	DDX_CBIndex(pDX, IDC_OBJ_AFF6, m_aff6);
	DDX_Text(pDX, IDC_OBJ_ALIAS, m_alias);
	DDX_Text(pDX, IDC_OBJ_LDESC, m_ldesc);
	DDX_Text(pDX, IDC_OBJ_MOD1, m_mod1);
	DDX_Text(pDX, IDC_OBJ_MOD2, m_mod2);
	DDX_Text(pDX, IDC_OBJ_MOD3, m_mod3);
	DDX_Text(pDX, IDC_OBJ_MOD4, m_mod4);
	DDX_Text(pDX, IDC_OBJ_MOD5, m_mod5);
	DDX_Text(pDX, IDC_OBJ_MOD6, m_mod6);
	DDX_Text(pDX, IDC_OBJ_RENT, m_rent);
	DDX_Text(pDX, IDC_OBJ_SDESC, m_sdesc);
	DDX_Text(pDX, IDC_OBJ_COST, m_cost);
	DDX_Text(pDX, IDC_OBJ_WEIGHT, m_weight);
	DDX_CBIndex(pDX, IDC_OBJ_TYPE, m_type);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(Oedit, CPropertyPage)
	//{{AFX_MSG_MAP(Oedit)
	ON_BN_CLICKED(IDC_PREV_OBJZ, OnPrevObjz)
	ON_BN_CLICKED(IDC_PREV_OBJ, OnPrevObj)
	ON_BN_CLICKED(IDC_NEXT_OBJ, OnNextObj)
	ON_BN_CLICKED(IDC_NEXT_OBJZ, OnNextObjz)
	ON_CBN_SELCHANGE(IDC_EXDESC_OKEYWORD, OnSelchangeExdescOkeyword)
	ON_BN_CLICKED(IDC_NEW_ODESC, OnNewOdesc)
	ON_EN_CHANGE(IDC_EXDESC_ODESC, OnChangeExdescOdesc)
	ON_BN_CLICKED(IDC_DELETE_ODESC, OnDeleteOdesc)
	ON_BN_CLICKED(IDC_OBJ_NUMBER, OnObjNumber)
	ON_BN_CLICKED(IDC_OBJ_WEAR, OnObjWear)
	ON_BN_CLICKED(IDC_OBJ_EFFECTS, OnObjEffects)
	ON_EN_CHANGE(IDC_OBJ_ALIAS, OnChangeObjAlias)
	ON_EN_CHANGE(IDC_OBJ_SDESC, OnChangeObjSdesc)
	ON_EN_CHANGE(IDC_OBJ_LDESC, OnChangeObjLdesc)
	ON_EN_CHANGE(IDC_OBJ_ADESC, OnChangeObjAdesc)
	ON_EN_CHANGE(IDC_OBJ_COST, OnChangeObjCost)
	ON_EN_CHANGE(IDC_OBJ_RENT, OnChangeObjRent)
	ON_EN_CHANGE(IDC_OBJ_WEIGHT, OnChangeObjWeight)
	ON_CBN_SELCHANGE(IDC_OBJ_TYPE, OnSelchangeObjType)
	ON_BN_CLICKED(IDC_VALUE4, OnValue4)
	ON_BN_CLICKED(IDC_VALUE1, OnValue1)
	ON_BN_CLICKED(IDC_VALUE2, OnValue2)
	ON_BN_CLICKED(IDC_VALUE3, OnValue3)
	ON_BN_CLICKED(IDC_OBJ_SAVEZONE, OnObjSavezone)
	ON_BN_CLICKED(IDC_OBJ_DELETE, OnObjDelete)
	ON_BN_CLICKED(IDC_OBJ_NEW, OnObjNew)
	//}}AFX_MSG_MAP
	ON_CONTROL_RANGE(CBN_SELCHANGE, IDC_OBJ_AFF1, IDC_OBJ_AFF6, OnAffChange)
	ON_CONTROL_RANGE(EN_CHANGE, IDC_OBJ_MOD1, IDC_OBJ_MOD6, OnAffChange)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// Oedit message handlers

extern World the_world;
extern CDirDialog ourlib;
extern CCbreakApp theApp;


/* this ought to be the opposite of fun. */





BOOL Oedit::OnSetActive() 
{
	if(theApp.dlg->current_obj >= 0) {
		LoadOedit();
	}
	return CPropertyPage::OnSetActive();
}

extern const char *obj_val_chart[NUM_OBJ_TYPES][4];

void Oedit::LoadOedit()
{
  int obj_vnum,i;
  vector<Ex_Desc_Data>::const_iterator exd;
  Obj *lobj;
  obj_vnum= theApp.dlg->current_obj;

  /* only have to do this for redit, because redit is activated as the first panel, before
     we load our data! */

	
	if(!are_there_zones()) {
    disable_oedit(-1);
	} else if (the_world.obj_list.empty()) {
		disable_oedit(0);
	} else {
		disable_oedit(1);
  }

  if(obj_vnum < 0) {
	  return ;
  }

  lobj = &(the_world.obj_list[obj_vnum]);

  m_alias=lobj->alias.c_str();
  m_obj_num.SetWindowText(iprintf("%d",lobj->number));
  m_adesc = lobj->adesc.c_str();
	m_cost = lobj->cost;
	m_ldesc = lobj->ldesc.c_str();
  m_rent = lobj->rent;
	m_sdesc = lobj->sdesc.c_str();
	m_type = lobj->type - 1;

	m_weight = lobj->weight;

  m_exdesc_string = "";
	((CComboBox *) GetDlgItem(IDC_EXDESC_OKEYWORD))->ResetContent();
  
	if(!lobj->exdesc.empty()) {
    for(exd = lobj->exdesc.begin();exd != lobj->exdesc.end();exd++) {
	   ((CComboBox *) GetDlgItem(IDC_EXDESC_OKEYWORD))->AddString(exd->keyword.c_str());
		}
		exd=lobj->exdesc.begin();
	  ((CComboBox *) GetDlgItem(IDC_EXDESC_OKEYWORD))->SelectString(-1,exd->keyword.c_str());
	  m_exdesc_string = exd->desc.c_str();

	}
 
  if(!lobj->exdesc.size()) {
	  ((CEdit *) GetDlgItem(IDC_EXDESC_ODESC))->SetReadOnly(TRUE);
		GetDlgItem(IDC_EXDESC_OKEYWORD)->EnableWindow(FALSE);
  } else {
	  ((CEdit *) GetDlgItem(IDC_EXDESC_ODESC))->SetReadOnly(FALSE);
		GetDlgItem(IDC_EXDESC_OKEYWORD)->EnableWindow(TRUE);
  }

	m_aff1=-1;
	m_mod1=0;
	m_aff2=-1;
	m_mod2=0;
	m_aff3=-1;
	m_mod3=0;
	m_aff4=-1;
	m_mod4=0;
	m_aff5=-1;
	m_mod5=0;
	m_aff6=-1;
	m_mod6=0;

	/* fall through.. i love you *kisses with tongue* *lalalaaaa* (tongue noises) */

  for(i=0;lobj->affs[i].atype > 0 && i< 6;i++);

	switch(i) {
		case 6:
			m_aff6=lobj->affs[5].atype;
			m_mod6=lobj->affs[5].modifier;
		case 5:
			m_aff5=lobj->affs[4].atype;
			m_mod5=lobj->affs[4].modifier;
		case 4:
			m_aff4=lobj->affs[3].atype;
			m_mod4=lobj->affs[3].modifier;
		case 3:
			m_aff3=lobj->affs[2].atype;
			m_mod3=lobj->affs[2].modifier;
		case 2:
			m_aff2=lobj->affs[1].atype;
			m_mod2=lobj->affs[1].modifier;
		case 1:
			m_aff1=lobj->affs[0].atype;
			m_mod1=lobj->affs[0].modifier;
    case 0:
			break;
		default:
			error("You will bow down to the almighty cornholio!");
			break;
	}

  GetDlgItem(IDC_VALUE1)->ShowWindow(SW_HIDE);
	GetDlgItem(IDC_VALUE2)->ShowWindow(SW_HIDE);
	GetDlgItem(IDC_VALUE3)->ShowWindow(SW_HIDE);
	GetDlgItem(IDC_VALUE4)->ShowWindow(SW_HIDE);
  /* okay. lets show the windows */
  if(_stricmp("*",obj_val_chart[m_type][0])) {
		GetDlgItem(IDC_VALUE1)->ShowWindow(SW_SHOW);
    m_val1.SetWindowText(iprintf("%s",obj_val_chart[m_type][0]));
	}

  if(_stricmp("*",obj_val_chart[m_type][1])) {
		GetDlgItem(IDC_VALUE2)->ShowWindow(SW_SHOW);
    m_val2.SetWindowText(iprintf("%s",obj_val_chart[m_type][1]));
	}

	if(_stricmp("*",obj_val_chart[m_type][2])) {
		GetDlgItem(IDC_VALUE3)->ShowWindow(SW_SHOW);
    m_val3.SetWindowText(iprintf("%s",obj_val_chart[m_type][2]));
	}

	if(_stricmp("*",obj_val_chart[m_type][3])) {
		GetDlgItem(IDC_VALUE4)->ShowWindow(SW_SHOW);
    m_val4.SetWindowText(iprintf("%s",obj_val_chart[m_type][3]));
	}

  this->UpdateData(FALSE);
}

void Oedit::OnPrevObjz() 
{
  extern CCbreakApp theApp;
  int obj_num = theApp.dlg->current_obj;
  map<int,Zone_Data>::const_iterator zi;
  map<int,Obj>::const_iterator ri;

	zi = the_world.zone_list.find(the_world.obj_list[obj_num].zone);
	if(zi==the_world.zone_list.end()) {
		error("Crapbuger. The current zone does not exist.");
	}
  	
	for(ri=the_world.obj_list.find(obj_num);ri != the_world.obj_list.begin();ri--) {
  	if(the_world.obj_list[ri->first].zone != the_world.obj_list[obj_num].zone) {
      break;
		}
	}

	if(ri == the_world.obj_list.begin() && the_world.obj_list[ri->first].zone ==
			the_world.obj_list[obj_num].zone) {
		ri=the_world.obj_list.end();
		ri--;
	}

	theApp.dlg->current_obj = ri->first;
	this->LoadOedit();		
}

void Oedit::OnPrevObj() 
{
	extern CCbreakApp theApp;
  int obj_num = theApp.dlg->current_obj;
  map<int, Obj>::const_iterator ri;

	ri=the_world.obj_list.find(obj_num);
	if(ri == the_world.obj_list.end()) {
		/* this is a serious problem. indicates the current obj DNE! */
		error("Uh. The current obj doesn't exist?");
	} 
	if(ri == the_world.obj_list.begin()) {
		ri= the_world.obj_list.end();
	}
	ri--;
	if(ri == the_world.obj_list.end()) {
		ri=the_world.obj_list.begin();
  }
	theApp.dlg->current_obj = ri->first;

	LoadOedit();	
}

void Oedit::OnNextObj() 
{
	extern CCbreakApp theApp;
  int obj_num = theApp.dlg->current_obj;
  map<int, Obj>::const_iterator ri;

	ri=the_world.obj_list.find(obj_num);
	if(ri == the_world.obj_list.end()) {
		/* this is a serious problem. indicates the current obj DNE! */
		error("Uh. The current obj doesn't exist?");
	} 
	ri++;
	if(ri == the_world.obj_list.end()) {
		ri=the_world.obj_list.begin();
  }
	theApp.dlg->current_obj = ri->first;

	LoadOedit();	
}

void Oedit::OnNextObjz() 
{
	extern CCbreakApp theApp;
  int obj_num = theApp.dlg->current_obj;
  map<int,Zone_Data>::const_iterator zi;
  map<int,Obj>::const_iterator ri;

	zi = the_world.zone_list.find(the_world.obj_list[obj_num].zone);
	if(zi==the_world.zone_list.end()) {
		error("Crapbuger. The current zone does not exist.");
	}
  	
	for(ri=the_world.obj_list.find(obj_num);ri != the_world.obj_list.end();ri++) {
  	if(the_world.obj_list[ri->first].zone != the_world.obj_list[obj_num].zone) {
      break;
		}
	}
	if(ri == the_world.obj_list.end()) {
		ri=the_world.obj_list.begin();
	}

	theApp.dlg->current_obj = ri->first;
	this->LoadOedit();	
}



void Oedit::OnSelchangeExdescOkeyword() 
{
	vector<Ex_Desc_Data>::const_iterator exd;
	int count;
	extern World the_world;
	extern CCbreakApp theApp;
  Obj *lobj;
	int obj_vnum= theApp.dlg->current_obj;	

  lobj = &(the_world.obj_list[obj_vnum]);
	count=((CComboBox *) GetDlgItem(IDC_EXDESC_OKEYWORD))->GetCurSel();
	
	for(exd=lobj->exdesc.begin();count > 0;count--) {
	  exd++;	
  }
	
	m_exdesc_string=exd->desc.c_str();
	
	UpdateData(FALSE);	
}

void Oedit::OnNewOdesc() 
{
	ExdescAdd exa(1);
	exa.DoModal();
}

void Oedit::OnChangeExdescOdesc() 
{
	vector<Ex_Desc_Data>::iterator exd;
	int count;
	extern World the_world;
	extern CCbreakApp theApp;
  Obj *lobj;
	int obj_vnum= theApp.dlg->current_obj;	

	UpdateData(TRUE);
  lobj = &(the_world.obj_list[obj_vnum]);
	count=((CComboBox *) GetDlgItem(IDC_EXDESC_OKEYWORD))->GetCurSel();
	
	for(exd=lobj->exdesc.begin();count > 0;count--) {
	  exd++;	
  }
	/* wonder if this will work. Both 'support' to<=>from char * conversions but not
		 work well with others */ 
	exd->desc = m_exdesc_string;
}

void Oedit::OnDeleteOdesc() 
{
	CString temp;

	Obj *lobj;
	int obj_vnum= theApp.dlg->current_obj;
  lobj = &(the_world.obj_list[obj_vnum]);
	((CComboBox *) GetDlgItem(IDC_EXDESC_OKEYWORD))->GetWindowText(temp);
	lobj->delete_exdata(iprintf("%s",temp));
	LoadOedit();	
}

void Oedit::OnAffChange(UINT nId) 
{
	Obj *lobj;
	int obj_vnum= theApp.dlg->current_obj;

	lobj = &(the_world.obj_list[obj_vnum]);

  UpdateData(TRUE);

	if(m_aff1 > 0) {
		
		lobj->affs[0].atype = m_aff1;
		lobj->affs[0].modifier = m_mod1;
	}
	if(m_aff1 > 0) {
		lobj->affs[1].atype = m_aff2;
		lobj->affs[1].modifier = m_mod2;
	}
	if(m_aff1 > 0) {
		lobj->affs[2].atype = m_aff3;
		lobj->affs[2].modifier = m_mod3;
	}
	if(m_aff1 > 0) {
		lobj->affs[3].atype = m_aff4;
		lobj->affs[3].modifier = m_mod4;
	}
	if(m_aff1 > 0) {
		lobj->affs[4].atype = m_aff5;
		lobj->affs[4].modifier = m_mod5;
	}
	if(m_aff1 > 0) {
		lobj->affs[5].atype = m_aff6;
		lobj->affs[5].modifier = m_mod6;
	}
}


void Oedit::OnObjNumber() 
{
  JumpToObj jumper;
	jumper.DoModal();
}

void Oedit::OnObjWear() 
{
	BitvectorSel ef(the_world.obj_list[theApp.dlg->current_obj].wear,"Wear Flags");
  ef.DoModal();
  the_world.obj_list[theApp.dlg->current_obj].wear = ef.total;
}

void Oedit::OnObjEffects() 
{
	BitvectorSel ef(the_world.obj_list[theApp.dlg->current_obj].effects,"Effect Flags");
    ef.DoModal();
    the_world.obj_list[theApp.dlg->current_obj].effects = ef.total;
}

void Oedit::OnChangeObjAlias() 
{
  Obj *lobj;

	int obj_vnum= theApp.dlg->current_obj;
  UpdateData(TRUE);
  lobj = &(the_world.obj_list[obj_vnum]);
  lobj->alias = m_alias;
}

void Oedit::OnChangeObjSdesc() 
{
  Obj *lobj;

	int obj_vnum= theApp.dlg->current_obj;
  UpdateData(TRUE);
  lobj = &(the_world.obj_list[obj_vnum]);
  lobj->sdesc = m_sdesc;
}

void Oedit::OnChangeObjLdesc() 
{
  Obj *lobj;

	int obj_vnum= theApp.dlg->current_obj;
  UpdateData(TRUE);
  lobj = &(the_world.obj_list[obj_vnum]);
  lobj->ldesc = m_ldesc;	
}

void Oedit::OnChangeObjAdesc() 
{
  Obj *lobj;

	int obj_vnum= theApp.dlg->current_obj;
  UpdateData(TRUE);
  lobj = &(the_world.obj_list[obj_vnum]);
  lobj->adesc = m_adesc;
}

void Oedit::OnChangeObjCost() 
{
  Obj *lobj;

	int obj_vnum= theApp.dlg->current_obj;
  UpdateData(TRUE);
  lobj = &(the_world.obj_list[obj_vnum]);
  lobj->cost = m_cost;
}

void Oedit::OnChangeObjRent() 
{
  Obj *lobj;

	int obj_vnum= theApp.dlg->current_obj;
  UpdateData(TRUE);
  lobj = &(the_world.obj_list[obj_vnum]);
  lobj->rent = m_rent;	
}

void Oedit::OnChangeObjWeight() 
{
  Obj *lobj;

	int obj_vnum= theApp.dlg->current_obj;
  UpdateData(TRUE);
  lobj = &(the_world.obj_list[obj_vnum]);
  lobj->weight = m_weight;	
}

void Oedit::OnSelchangeObjType() 
{
  Obj *lobj;

	int obj_vnum= theApp.dlg->current_obj;
  UpdateData(TRUE);
  lobj = &(the_world.obj_list[obj_vnum]);
  lobj->type = m_type + 1;
  set_value_defaults();
  LoadOedit();
}

extern int obj_val_defaults[NUM_OBJ_TYPES][4];

void Oedit::set_value_defaults()
{
  Obj *lobj;
	int obj_vnum= theApp.dlg->current_obj;
  lobj = &(the_world.obj_list[obj_vnum]);

  UpdateData(TRUE);

	lobj->value[0] = obj_val_defaults[lobj->type-1][0];
	lobj->value[1] = obj_val_defaults[lobj->type-1][1];
	lobj->value[2] = obj_val_defaults[lobj->type-1][2];
	lobj->value[3] = obj_val_defaults[lobj->type-1][3];

}

BOOL Oedit::OnInitDialog() 
{
	CPropertyPage::OnInitDialog();
	
	if(!are_there_zones()) {
    disable_oedit(-1);
	} else if (the_world.obj_list.empty()) {
		disable_oedit(0);
	} else {
		disable_oedit(1);
  }
  set_value_defaults();	
	return TRUE;  
}

void Oedit::OnValue1() 
{
  Obj *lobj;
	int obj_vnum= theApp.dlg->current_obj;
  IntQuery *iq;

  lobj = &(the_world.obj_list[obj_vnum]);
	
	switch(lobj->type) {
		case O_FOOD:
       iq=new IntQuery("Food","How many hours to fill stomach?",lobj->value[0]);
			 iq->DoModal();
			 lobj->value[0] = iq->value;
			 delete iq;
			 break;
		case O_SCROLL:
		case O_WAND:
		case O_STAFF:
		case O_POTION:
       iq=new IntQuery("Level","What level should these spells be cast at?",lobj->value[0]);
			 iq->DoModal();
			 lobj->value[0] = iq->value;
			 delete iq;
			 break;
    case O_ARMOR:
			 iq=new IntQuery("Armor Class","Enter the Armor Class of this item?",lobj->value[0]);
			 iq->DoModal();
			 lobj->value[0] = iq->value;
			 delete iq;
			 break;
		case O_CONTAINER:
		case O_DRINKCON:
		case O_FOUNTAIN:
			 iq=new IntQuery("Capacity","What is the carrying capcity of this container?",lobj->value[0]);
			 iq->DoModal();
			 lobj->value[0] = iq->value;
			 delete iq;
			 break;
		case O_MONEY:
			 iq=new IntQuery("Gold","How many coins is this worth?",lobj->value[0]);
			 iq->DoModal();
			 lobj->value[0] = iq->value;
			 delete iq;
			 break;
		default:
			TRACE0("Default case reached in OnValue1!\n");
			break;
	}
}

void Oedit::OnValue2() 
{
  Obj *lobj;
	int obj_vnum= theApp.dlg->current_obj;
  IntQuery *iq;
  SpellQuery *sq;
  QueryCont *qc;

  lobj = &(the_world.obj_list[obj_vnum]);

	switch(lobj->type) {
		case O_WAND:
    case O_STAFF:
			iq=new IntQuery("Charges","What's the maximum charge capacity?",lobj->value[1]);
			iq->DoModal();
			lobj->value[1] = iq->value;
			delete iq;
			break;
		case O_WEAPON:
			iq=new IntQuery("Dice","Number of Damage dice?",lobj->value[1]);
			iq->DoModal();
		  lobj->value[1] = iq->value;
			delete iq;
			break;
		case O_SCROLL:
		case O_POTION:
			sq=new SpellQuery("Spell Selection","Which spell to use?",lobj->value[1]);
			sq->DoModal();
			lobj->value[1] = sq->value;
			delete sq;
			break;
		case O_DRINKCON:
		case O_FOUNTAIN:
			 iq=new IntQuery("Capacity","What is the current capcity of this container?",lobj->value[1]);
			 iq->DoModal();
			 lobj->value[1] = iq->value;
			 delete iq;
			 break;
		case O_CONTAINER:
			 qc = new QueryCont(lobj->value[1]);
			 qc->DoModal();
			 lobj->value[1] = qc->value;
			 delete qc;
			 break;
    default:
			TRACE0("Default case reached in OnValue2!\n");
			break;
	}	
}

void Oedit::OnValue3() 
{
  Obj *lobj;
	int obj_vnum= theApp.dlg->current_obj;
  IntQuery *iq;
  SpellQuery *sq;
  LiquidQuery *lq;

  lobj = &(the_world.obj_list[obj_vnum]);
	
	switch(lobj->type) {
		case O_LIGHT:
			iq = new IntQuery("Light Hours","How many hours for the light to last? (-1 is infinite)",
				lobj->value[2]);
			iq->DoModal();
			lobj->value[2] = iq->value;
			delete iq;
			break;
		case O_WAND:
    case O_STAFF:
			iq=new IntQuery("Charges","What's the current number of  charges?",lobj->value[2]);
			iq->DoModal();
			lobj->value[2] = iq->value;
			delete iq;
			break;
		case O_WEAPON:
			iq=new IntQuery("Dice","What's the size of a damage dice?",lobj->value[2]);
			iq->DoModal();
			lobj->value[2] = iq->value;
			delete iq;
			break;
		case O_CONTAINER:
			iq=new IntQuery("Key","What's the key vnum?",lobj->value[2]);
			iq->DoModal();
			lobj->value[2] = iq->value;
			delete iq;			
			break;
		case O_SCROLL:
		case O_POTION:
			sq=new SpellQuery("Spell Selection","Which spell to use?",lobj->value[2]);
			sq->DoModal();
			lobj->value[2] = sq->value;
			delete sq;
			break;
		case O_DRINKCON:
		case O_FOUNTAIN:
      lq=new LiquidQuery("Liquid Selection","Filled with which liquid?",lobj->value[2]);
			lq->DoModal();
			lobj->value[2]=lq->value;
			delete lq;
			break;
		default:
			TRACE0("Default case reached in OnValue3!\n");
			break;
	}
}

void Oedit::OnValue4() 
{
  Obj *lobj;
	int obj_vnum= theApp.dlg->current_obj;
	YesNoQuery *ynq;
  SpellQuery *sq;
  WeaponQuery *wq;

  lobj = &(the_world.obj_list[obj_vnum]);
  switch(lobj->type) {
		case O_FOOD:
		case O_DRINKCON:
		case O_FOUNTAIN:
			ynq=new YesNoQuery("Poison","Is it poisoned??",lobj->value[3]);
			ynq->DoModal();
			lobj->value[3] = ynq->value;
			delete ynq;
			break;
		case O_SCROLL:
		case O_POTION:
		case O_WAND:
		case O_STAFF:
			sq=new SpellQuery("Spell Selection","Which spell to use?",lobj->value[3]);
			sq->DoModal();
			lobj->value[3] = sq->value;
			delete sq;
			break;
		case O_WEAPON:
			wq = new WeaponQuery(lobj->value[3]);
			wq->DoModal();
			lobj->value[3] = wq->value;
			delete wq;
			break;
		default:
						TRACE0("Default case reached in OnValue4!\n");
			break;
	}
}

void Oedit::OnObjSavezone() 
{
  int zone = the_world.room_list[theApp.dlg->current_obj].zone;
  the_world.save_zone(zone);
    AfxMessageBox("The zone is saved.\n",MB_OK);
}

void Oedit::OnObjDelete() 
{
  int delobj = theApp.dlg->current_obj;

  if(AfxMessageBox("Are you sure you wish to delete this object?",
	  MB_YESNO | MB_APPLMODAL | MB_ICONQUESTION) == IDYES) {
    OnNextObj();
    the_world.obj_list.erase(delobj);
  }		
}

void Oedit::OnObjNew() 
{
  NewObj no;
  no.DoModal();
}

void Oedit::disable_oedit(int all)
{
  int i;

	for(i=ID_ZONE_NUMBER;i <IDC_ZCMD_SAVE;i++){
		if(GetDlgItem(i)) {
      GetDlgItem(i)->EnableWindow(FALSE);
		}
	}
	if(all == -1) {
		return;
	}
  GetDlgItem(IDC_OBJ_SAVEZONE)->EnableWindow(TRUE);
  GetDlgItem(IDC_OBJ_NEW)->EnableWindow(TRUE);

	if(all == 1) {
  	for(i=ID_ZONE_NUMBER;i <IDC_ZCMD_SAVE;i++){
	  	if(GetDlgItem(i)) {
        GetDlgItem(i)->EnableWindow(TRUE);
			}
		}
	}
}
